# reuterscom.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo4
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# visit #newsticker@ircnet
#
# grabs the headlines from www.reuters.com... as usual.
#
# v1.0 - first public version
#
# reuterscomtrigger - der trigger auf den der bot reagiert (public und message)
# reuterscomlimit - maximum der news die auf befehl geposted werden
# reuterscomnewspost  - 1 fr newsposting, 0 fr keines
# reuterscomchans  - die  chans in  denen das tcl aktiv  ist, "" fr alle
# reuterscomnewspostlimit - maximum der news die geposted werden
# isreuterscomhub  - legt fest ob der bot newshub ist oder nicht
# reuterscomleafs  - die nicks der leafbots auf denen das leaf tcl luft
#
####### config ######################

set reuterscomtrigger ".reuterscom"
set reuterscomchans ""
set reuterscomlimit "10"
set reuterscomnewspostlimit "3"
set reuterscomnewspost "1"
set isreuterscomhub "0"
set reuterscomleafs ""

####### ende der config #############

bind msg - $reuterscomtrigger msg_reuterscom
bind pub - $reuterscomtrigger pub_reuterscom
bind time - "?0 * * * *" reuterscomcheck

proc sendreuterscomnews { arg } {
global reuterscomleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $reuterscomleafs] [string tolower $bot]] != -1)} {
putbot $bot "reuterscom: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }


proc html { text } {
regsub -all "&uuml;" $text "" text
regsub -all "&ouml;" $text "" text
regsub -all "&auml;" $text "" text
regsub -all "&Uuml;" $text "" text
regsub -all "&Ouml;" $text "" text
regsub -all "&Auml;" $text "" text
regsub -all "&szlig;" $text "" text
regsub -all "&quot;" $text "\"" text
regsub -all "&amp;" $text "&" text
regsub -all "<sub>" $text "" text
regsub -all "&lt;" $text "<" text
regsub -all "&gt;" $text ">" text
regsub -all "&#39;" $text "'" text
return $text
}


proc reuterscomcheck {nick uhost hand chan arg} {
global reuterscomchans reuterscomnewspost isreuterscomhub reuterscomnewspostlimit
set counter 0
if {$reuterscomnewspost == 1 } {
putlog "reuterscom: suche nach neuer newsline"
set reuterscomlastnews "none"
if {[file exists reuterscom.hdl]} {
set temp [open "reuterscom.hdl" r]
set reuterscomlastnews "[gets $temp]"
if {$reuterscomlastnews == ""} { set reuterscomlastnews "none" }
close $temp
}
set temp [open "reuterscom.hdl" w+]
if {[catch {set sock [socket www.reuters.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /newsEarlierArticles.jhtml?type=topNews&articlePage=firstpage HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.reuters.com"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"earlyHeadline\"" $bl] != -1} {
set newsline [string range $bl [expr [string last "\">" $bl] + 2] [shrink - 1 "</a>" 0 $bl]]
set link www.reuters.com/newsArticle.jhtml[string range $bl [shrink - 0 "?type" 0 $bl] [expr [string last "\">" $bl] - 1]]
puts $temp "[html $newsline] <$link>"
}}}
close $sock ; close $temp
if {$reuterscomlastnews == "none" } { putlog "reuterscom: headlinefile created" ; return 0 }
set temp [open "reuterscom.hdl" r]
while { [eof $temp] != 1 } {
set reuterscomneunews [gets $temp]
if {($reuterscomlastnews == $reuterscomneunews) || ($counter == $reuterscomnewspostlimit)} { close $temp;return 0 }
incr counter
foreach chan [channels] {
if {$reuterscomchans == "" } { putserv "privmsg $chan :(neue reuterscom newsline) $reuterscomneunews" }
if {$reuterscomchans != "" } {
if {([lsearch -exact [string tolower $reuterscomchans] [string tolower $chan]] != -1) || ($reuterscomchans == "")} {putserv "privmsg $chan :(neue reuterscom newsline) $reuterscomneunews"}
}
if { $isreuterscomhub == "1" } { sendreuterscomnews $reuterscomneunews }
}}}}


proc reuterscomnews {target limit} {
if {[catch {set sock [socket www.reuters.com 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /newsEarlierArticles.jhtml?type=topNews&articlePage=firstpage HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: www.reuters.com"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "class=\"earlyHeadline\"" $bl] != -1} {
set newsline [string range $bl [expr [string last "\">" $bl] + 2] [shrink - 1 "</a>" 0 $bl]]
set link www.reuters.com/newsArticle.jhtml[string range $bl [shrink - 0 "?type" 0 $bl] [expr [string last "\">" $bl] - 1]]
putserv "privmsg $target :[incr counter] [html $newsline] <$link>"
}
if {$counter == $limit} {close $sock ; return 0 }
}}}

proc msg_reuterscom { nick uhost hand arg } { global reuterscomlimit ; reuterscomnews $nick $reuterscomlimit }
proc pub_reuterscom { nick uhost hand chan arg } { global reuterscomchans reuterscomlimit ; if {([lsearch -exact [string tolower $reuterscomchans] [string tolower $chan]] != -1) || ($reuterscomchans == "")} { reuterscomnews $nick $reuterscomlimit }}

putlog "*** reuterscom.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]